searchNodes=[{"doc":"Making the IEx console friendlier one command at a timeTo use the helpers, run:iex&gt; use ToolshedAdd this to your .iex.exs to load automatically.The following is a list of helpers:cat/1 - print out a filecmd/1 - run a system command and print the outputdate/0 - print out the current date and timedmesg/0 - print kernel messages (Nerves-only)exit/0 - exit out of an IEx sessionfw_validate/0 - marks the current image as valid (check Nerves system if supported)grep/2 - print out lines that match a regular expressionhex/1 - print a number as hexhttpget/2 - print or download the results of a HTTP GET requesthostname/0 - print our hostnameifconfig/0 - print info on network interfacesload_term!/2 - load a term that was saved by save_term/2lsof/0 - print out open file handles by OS processlsmod/0 - print out what kernel modules have been loaded (Nerves-only)lsusb/0 - print info on USB devicesmulticast_addresses/0 - print out all multicast addressesnslookup/1 - query DNS to find an IP addresspastebin/1 - post text to a pastebin server (requires networking)ping/2 - ping a remote host (but use TCP instead of ICMP)qr_encode/1 - create a QR code (requires networking)reboot/0 - reboots gracefully (Nerves-only)reboot!/0 - reboots immediately (Nerves-only)save_value/2 - save a value to a file as Elixir terms (uses inspect)save_term!/2 - save a term as a binarytop/2 - list out the top processestping/2 - check if a host can be reached (like ping, but uses TCP)tree/1 - pretty print a directory treeuptime/0 - print out the current Erlang VM uptimeuname/0 - print information about the running system (Nerves-only)weather/0 - get the local weather (requires networking)","ref":"Toolshed.html","title":"Toolshed","type":"module"},{"doc":"Run a command and return the exit code. This function is intended to be run interactively.","ref":"Toolshed.html#cmd/1","title":"Toolshed.cmd/1","type":"function"},{"doc":"Inspect a value with all integers printed out in hex. This is useful for one-off hex conversions. If you're doing a lot of work that requires hexadecimal output, you should consider running:IEx.configure(inspect: [base: :hex])The drawback of doing the above is that strings print out as hex binaries.","ref":"Toolshed.html#hex/1","title":"Toolshed.hex/1","type":"function"},{"doc":"Add path completion to the default IEx autocompletionThis modules augments the IEx autocompletion logic to complete file paths in strings. This lets you tab the paths in calls to Toolshed helpers and functions like File.read/1.","ref":"Toolshed.Autocomplete.html","title":"Toolshed.Autocomplete","type":"module"},{"doc":"Handle autocomplete callsThis function handles path autocompletion and if that's not appropriate, it delegates to IEx.Autocomplete for normal completion.See set_expand_fun/0 for manual registration.","ref":"Toolshed.Autocomplete.html#expand/1","title":"Toolshed.Autocomplete.expand/1","type":"function"},{"doc":"Set the IO server's :expand_funThis is a slightly modified version of IEx.Autocomplete.set_expand_fun/0 to register the autocompletion logic. It is normally called by use Toolshed, but may be called manually as well.","ref":"Toolshed.Autocomplete.html#set_expand_fun/0","title":"Toolshed.Autocomplete.set_expand_fun/0","type":"function"},{"doc":"","ref":"Toolshed.Autocomplete.html#t:result/0","title":"Toolshed.Autocomplete.result/0","type":"type"},{"doc":"Helpers that make HTTP requests","ref":"Toolshed.HTTP.html","title":"Toolshed.HTTP","type":"module"},{"doc":"Perform a HTTP GET request for the specified URLBy default, the results are printed or you can optionally choose to download it to a specific location on the file system.Options::dest - File path to write the response to. Defaults to printing to the terminal.:verbose - Display request and response headers. Disabled by default.","ref":"Toolshed.HTTP.html#httpget/2","title":"Toolshed.HTTP.httpget/2","type":"function"},{"doc":"Post text to a paste serviceThis is a convenient way of sharing text data with others. It currently posts to &quot;exbin.call-cc.be&quot;. Keep in mind that the text is posted in the clear and the server may retain it indefinitely.On success, this function returns a URL to the posted text.","ref":"Toolshed.HTTP.html#pastebin/1","title":"Toolshed.HTTP.pastebin/1","type":"function"},{"doc":"Generate an ASCII art QR codeSee https://github.com/chubin/qrenco.de for more information.","ref":"Toolshed.HTTP.html#qr_encode/1","title":"Toolshed.HTTP.qr_encode/1","type":"function"},{"doc":"Display the local weatherSee http://wttr.in/:help for more information.","ref":"Toolshed.HTTP.html#weather/0","title":"Toolshed.HTTP.weather/0","type":"function"},{"doc":"Helpers that are useful for querying hardware information. These are Linux/Nerves-specific.Helpers include:lsusb/0 - print out connected USB devices","ref":"Toolshed.HW.html","title":"Toolshed.HW","type":"module"},{"doc":"Print out information on all of the connected USB devices.","ref":"Toolshed.HW.html#lsusb/0","title":"Toolshed.HW.lsusb/0","type":"function"},{"doc":"List out open files by process","ref":"Toolshed.Lsof.html","title":"Toolshed.Lsof","type":"module"},{"doc":"List out open files by processThis is an simple version of lsof that works on Linux and Nerves. While running the normal version of lsof provides more information, this can be convenient when lsof isn't easily available or can't be run due to :emfile errors from starting port processes due to too many files being open..","ref":"Toolshed.Lsof.html#lsof/0","title":"Toolshed.Lsof.lsof/0","type":"function"},{"doc":"Miscellaneous helpers","ref":"Toolshed.Misc.html","title":"Toolshed.Misc","type":"module"},{"doc":"Exit the current IEx session","ref":"Toolshed.Misc.html#exit/0","title":"Toolshed.Misc.exit/0","type":"function"},{"doc":"Load an Erlang term from the filesystem.Examples#iex&gt; save_term!({:some_interesting_atom, [&quot;some&quot;, &quot;list&quot;]}, &quot;/root/some_atom.term&quot;) {:some_interesting_atom, [&quot;some&quot;, &quot;list&quot;]} iex&gt; load_term!(&quot;/root/some_atom.term&quot;) {:some_interesting_atom, [&quot;some&quot;, &quot;list&quot;]}","ref":"Toolshed.Misc.html#load_term!/1","title":"Toolshed.Misc.load_term!/1","type":"function"},{"doc":"Save an Erlang term to the filesystem for easy loading laterThis function returns the value passed in to allow easy piping.Examples#iex&gt; :sys.get_state(MyServer) |&gt; save_term!(&quot;/root/my_server.term&quot;) # Reboot board iex&gt; :sys.replace_state(&amp;load_term!(&quot;/root/my_server.term&quot;))","ref":"Toolshed.Misc.html#save_term!/2","title":"Toolshed.Misc.save_term!/2","type":"function"},{"doc":"Save a value to a file as Elixir termsExamples# Save the contents of SystemRegistry to a file iex&gt; SystemRegistry.match(:_) |&gt; save_value(&quot;/root/sr.txt&quot;) :ok","ref":"Toolshed.Misc.html#save_value/3","title":"Toolshed.Misc.save_value/3","type":"function"},{"doc":"Multicast utilities","ref":"Toolshed.Multicast.html","title":"Toolshed.Multicast","type":"module"},{"doc":"List all active multicast addressesThis lists out multicast addresses by network interface similar to ip maddr show. It currently only works on Linux.","ref":"Toolshed.Multicast.html#multicast_addresses/0","title":"Toolshed.Multicast.multicast_addresses/0","type":"function"},{"doc":"Helper for processing the multicast subscription information files","ref":"Toolshed.Multicast.html#process_proc/3","title":"Toolshed.Multicast.process_proc/3","type":"function"},{"doc":"Helpers that are useful on Nerves devicesHelpers include:dmesg/0 - print kernel messagesfw_validate/0 - marks the current image as valid (check Nerves system if supported)lsmod/0 - print out what kernel modules have been loadedreboot/0 - reboots gracefullyreboot!/0 - reboots immediatelyuname/0 - print information about the running system","ref":"Toolshed.Nerves.html","title":"Toolshed.Nerves","type":"module"},{"doc":"Print out kernel log messages","ref":"Toolshed.Nerves.html#dmesg/0","title":"Toolshed.Nerves.dmesg/0","type":"function"},{"doc":"Validate a firmware imageAll official Nerves Systems automatically validate newly installed firmware. For some systems, it's possible to disable this so that new firmware gets one chance to boot. If it's not &quot;validated&quot; before a reboot, then the device reverts to the old firmware.","ref":"Toolshed.Nerves.html#fw_validate/0","title":"Toolshed.Nerves.fw_validate/0","type":"function"},{"doc":"Print out the loaded kernel modulesAside from printing out whether the kernel has been tainted, the Linux utility of the same name just dump the contents of &quot;/proc/modules&quot; like this one.Some kernel modules may be built-in to the kernel image. To see those, run cat &quot;/lib/modules/x.y.z/modules.builtin&quot; where x.y.z is the kernel's version number.","ref":"Toolshed.Nerves.html#lsmod/0","title":"Toolshed.Nerves.lsmod/0","type":"function"},{"doc":"Shortcut to reboot a board. This is a graceful reboot, so it takes some time before the real reboot.","ref":"Toolshed.Nerves.html#reboot/0","title":"Toolshed.Nerves.reboot/0","type":"function"},{"doc":"Reboot immediately without a graceful shutdown. This is for the impatient.","ref":"Toolshed.Nerves.html#reboot!/0","title":"Toolshed.Nerves.reboot!/0","type":"function"},{"doc":"Print out information about the running softwareThis is similar to the Linux uname to help people remember what to type.","ref":"Toolshed.Nerves.html#uname/0","title":"Toolshed.Nerves.uname/0","type":"function"},{"doc":"Network related helpers","ref":"Toolshed.Net.html","title":"Toolshed.Net","type":"module"},{"doc":"","ref":"Toolshed.Net.html#hostent/2","title":"Toolshed.Net.hostent/2","type":"macro"},{"doc":"Return the hostnameExamplesiex&gt; hostname &quot;nerves-1234&quot;","ref":"Toolshed.Net.html#hostname/0","title":"Toolshed.Net.hostname/0","type":"function"},{"doc":"Print out the network interfaces and their addresses.","ref":"Toolshed.Net.html#ifconfig/0","title":"Toolshed.Net.ifconfig/0","type":"function"},{"doc":"Lookup the specified hostname in the DNS and print out the addresses.Examplesiex&gt; nslookup &quot;google.com&quot; Name: google.com Address: 172.217.7.238 Address: 2607:f8b0:4004:804::200e","ref":"Toolshed.Net.html#nslookup/1","title":"Toolshed.Net.nslookup/1","type":"function"},{"doc":"Ping an IP address using TCPThis tries to connect to the remote host using TCP instead of sending an ICMP echo request like normal ping. This made it possible to write in pure Elixir.NOTE: Specifying an :ifname only sets the source IP address for the TCP connection. This is only a hint to use the specified interface and not a guarantee. For example, if you have two interfaces on the same LAN, the OS routing tables may send traffic out one interface in preference to the one that you want. On Linux, you can enable policy-based routing and add source routes to guarantee that packets go out the desired interface.Options::ifname - Specify a network interface to use. (e.g., &quot;eth0&quot;)Examplesiex&gt; ping &quot;nerves-project.org&quot; Press enter to stop Response from nerves-project.org (185.199.108.153): time=4.155ms Response from nerves-project.org (185.199.108.153): time=10.385ms Response from nerves-project.org (185.199.108.153): time=12.458ms iex&gt; ping &quot;google.com&quot;, ifname: &quot;wlp5s0&quot; Press enter to stop Response from google.com (172.217.7.206): time=88.602ms","ref":"Toolshed.Net.html#ping/2","title":"Toolshed.Net.ping/2","type":"function"},{"doc":"Check if a computer is up using TCP.Options::ifname - Specify a network interface to use. (e.g., &quot;eth0&quot;)Examplesiex&gt; tping &quot;nerves-project.org&quot; Response from nerves-project.org (185.199.108.153): time=4.155ms iex&gt; tping &quot;192.168.1.1&quot; Response from 192.168.1.1 (192.168.1.1): time=1.227ms","ref":"Toolshed.Net.html#tping/2","title":"Toolshed.Net.tping/2","type":"function"},{"doc":"Find the top processes","ref":"Toolshed.Top.html","title":"Toolshed.Top","type":"module"},{"doc":"List the top processesOptions::order - the sort order for the results (:reductions, :delta_reductions, :mailbox, :delta_mailbox, :total_heap_size, :delta_total_heap_size, :heap_size, :delta_heap_size, :stack_size, :delta_stack_size):n - the max number of processes to list","ref":"Toolshed.Top.html#top/1","title":"Toolshed.Top.top/1","type":"function"},{"doc":"","ref":"Toolshed.Top.html#top_heap_size/1","title":"Toolshed.Top.top_heap_size/1","type":"function"},{"doc":"","ref":"Toolshed.Top.html#top_mailbox/1","title":"Toolshed.Top.top_mailbox/1","type":"function"},{"doc":"","ref":"Toolshed.Top.html#top_reductions/1","title":"Toolshed.Top.top_reductions/1","type":"function"},{"doc":"","ref":"Toolshed.Top.html#top_stack_size/1","title":"Toolshed.Top.top_stack_size/1","type":"function"},{"doc":"","ref":"Toolshed.Top.html#top_total_heap_size/1","title":"Toolshed.Top.top_total_heap_size/1","type":"function"},{"doc":"Helpers for when your fingers are too used to typing Unix commands.Helpers include:cat/1 - print out a filedate/0 - print out the current date and timegrep/2 - print out lines of a file that match a regular expressiontree/1 - print out a directory treeuptime/0 - print the update of the Erlang VM","ref":"Toolshed.Unix.html","title":"Toolshed.Unix","type":"module"},{"doc":"Print out a file","ref":"Toolshed.Unix.html#cat/1","title":"Toolshed.Unix.cat/1","type":"function"},{"doc":"Print out the date similar to the Unix date command","ref":"Toolshed.Unix.html#date/0","title":"Toolshed.Unix.date/0","type":"function"},{"doc":"Run a regular expression on a file and print the matching lines.iex&gt; grep ~r/video/, &quot;/etc/mime.types&quot;","ref":"Toolshed.Unix.html#grep/2","title":"Toolshed.Unix.grep/2","type":"function"},{"doc":"Print out directories and files in tree form.","ref":"Toolshed.Unix.html#tree/1","title":"Toolshed.Unix.tree/1","type":"function"},{"doc":"Print out the current uptime.","ref":"Toolshed.Unix.html#uptime/0","title":"Toolshed.Unix.uptime/0","type":"function"},{"doc":"Toolshed Toolshed aims to improve the Elixir shell experience by adding a number of helpers and path autocompletion. This is really helpful when a normal Unix shell prompt is unavailable or inconvenient. Toolshed was originally written for Nerves, but doesn't require it and the Nerves-specific helpers are compiled out for normal Elixir projects.Here's a sample list of helpers:cmd - run a command and print out the outputtop - get a list of the top processes and their OTP applications based on CPU and memoryexit - exit an IEx session (useful over ssh)tree - list directory contents as a treesave_term/load_term - save and load Elixir terms to filesping - check if a remote host is up (almost like ping, but uses TCP instead of ICMP to avoid needing additional permissions)ifconfig - list network interfaceslsusb - list USB devicesTo get a complete list:iex&gt; h ToolshedTo try it out, add this project to your deps:def deps do [ {:toolshed, &quot;~&gt; 0.2&quot;} ] endRebuild and run in whatever way you prefer. At the IEx prompt, run:iex&gt; use Toolshed Toolshed imported. Run h(Toolshed) for more info. :ok iex&gt; cmd(&quot;echo hello world&quot;) hello world 0 iex&gt; ping &quot;nerves-project.org&quot; Press enter to stop Response from nerves-project.org (185.199.108.153): time=4.155ms Response from nerves-project.org (185.199.108.153): time=10.385ms Response from nerves-project.org (185.199.108.153): time=12.458ms iex&gt; top OTP Application Name or PID Reds/Δ Mbox/Δ Total/Δ Heap/Δ Stack/Δ nerves_runtime Nerves.Runtime.Kernel.UE 72M/10M 157/-32 384K/-4642 192K/73K 86/52 system_registry SystemRegistry.Global 41M/6134K 0/0 694K/192K 192K/0 35/-11 system_registry SystemRegistry.Processor 61M/6075K 0/0 73K/-1215 73K/0 10/0 system_registry SystemRegistry.Registrat 1623K/293K 1/1 211K/109K 73K/0 10/0 system_registry SystemRegistry.Processor 790K/197K 59/3 1011K/4461 502K/0 38/0 undefined #PID&lt;0.1793.0&gt; 221K/68K 0/0 21K/0 6772/0 504/0 system_registry SystemRegistry.Processor 382K/58K 0/0 16K/-1227 4185/-1354 22/0 ssh #PID&lt;0.1786.0&gt; 133K/52K 0/0 4184/1599 2586/1599 10/0 nerves_init_gadg #PID&lt;0.1432.0&gt; 213K/39K 0/0 192K/101K 73K/0 10/0When you get tired of typing use Toolshed, add it to your .iex.exs.","ref":"readme.html","title":"Toolshed","type":"extras"},{"doc":"I have some IEx helpers. Would you consider adding them?Yes! Absolutely. Please send a PR. At some point I may have to whittle down what's in the library, but for now, I'm open to adding almost anything.This includes:Pretty much anything that helps debugging or inspecting a running systemWrappers on OTP functions that are hard to remember or have output that's not ideal for interactive use.Fun stuff - submit a text game if it's not too long if you'd like.I'd really like to stay away from adding anything that's not Elixir to this project. I.e., no port processes or NIFs. It would also be nice to keep Toolshed low on dependencies. Of course, maybe I'm just not thinking of something. Don't let that be a reason to not file an issue proposing the idea. If it doesn't seem to fit well, maybe a simplified version does and we add a link to the full featured one.A lot of these look like Unix commands? Why not run a proper shell?Yeah, I miss many Unix commands when I'm at the IEx prompt. Switching to a shell is easy on my laptop, but on Nerves devices, it's a pain. Getting a shell prompt on Nerves is possible, but it's limited due to Nerves not containing a full set of commands and it having to be run through Erlang's job control.You can do so much more with some of these helpers!!!Definitely. There's so much that I'd like to explore, but time gets in the way. I'm not sold on many decisions that I made, but something was better than nothing. Please help me improve this or make your own IEx helpers library. I'm quite happy to use it too or pull it in as a dependency.I want to use one of the functions in my program. Is the API stable?This really isn't a normal hex.pm library. Use it for the helpers. If you want some code, copy and paste it or incorporate it into a library. I'd like the flexibility to change the API to improve interactive use.It would be better if you changed the colors.This also isn't a question, and you've now made me regret naming the project toolshed. Please file your grievances here.","ref":"readme.html#faq","title":"Toolshed - FAQ","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"New featuresAdd httpget command for performing HTTP GET requests and printing the response to stdout or saving it to the filesystem. Thanks to Jon Thacker for this feature.","ref":"changelog.html#v0-2-18","title":"Changelog - v0.2.18","type":"extras"},{"doc":"Bug fixesDon't trigger autocompletion when in a string interpolation.","ref":"changelog.html#v0-2-17","title":"Changelog - v0.2.17","type":"extras"},{"doc":"Bug fixesFix path completion issues when wildcard characters are in the string to be completed.","ref":"changelog.html#v0-2-16","title":"Changelog - v0.2.16","type":"extras"},{"doc":"New featuresAdd path autocompletion. Try it out by running use Toolshed at the IEx prompt. Then type File.read(&quot;/e&lt;tab&gt;&quot;) for files in /etc or ls &quot;li&lt;tab&gt;&quot; if you have a lib directory under your current directory.","ref":"changelog.html#v0-2-15","title":"Changelog - v0.2.15","type":"extras"},{"doc":"Bug fixesFix warnings when building with Elixir 1.11.","ref":"changelog.html#v0-2-14","title":"Changelog - v0.2.14","type":"extras"},{"doc":"Bug fixesImprove error message when :inets isn't available so that it says how to add it to your mix.exs.","ref":"changelog.html#v0-2-13","title":"Changelog - v0.2.13","type":"extras"},{"doc":"Bug fixesIf help has been stripped, then don't tell the user that it's available.New featuresAdd multicast_addresses command for listing multicast addresses being listened to on each network interface. This is helpful if you're debugging lost multicast subscriptions or just seeing what applications are listening on.","ref":"changelog.html#v0-2-12","title":"Changelog - v0.2.12","type":"extras"},{"doc":"New featuresAdd date command for quickly checking the current date and time in UTC","ref":"changelog.html#v0-2-11","title":"Changelog - v0.2.11","type":"extras"},{"doc":"New featuresValidate firmware using nerves_runtime v0.10.0's Nerves.Runtime.KV.put/2 function if available","ref":"changelog.html#v0-2-10","title":"Changelog - v0.2.10","type":"extras"},{"doc":"New featuresAdd simple HTTP request shortcuts: weather, qr_encode, and pastebin","ref":"changelog.html#v0-2-9","title":"Changelog - v0.2.9","type":"extras"},{"doc":"New featuresAdd ping to ping a remote IP address repeatedly and add some support for setting the interface to use.","ref":"changelog.html#v0-2-8","title":"Changelog - v0.2.8","type":"extras"},{"doc":"New featuresAdd lsmod for returning loaded kernel modules on Nerves","ref":"changelog.html#v0-2-7","title":"Changelog - v0.2.7","type":"extras"},{"doc":"New featuresAdd uname for getting running firmware information on Nerves","ref":"changelog.html#v0-2-6","title":"Changelog - v0.2.6","type":"extras"},{"doc":"New featuresAdd lsof","ref":"changelog.html#v0-2-5","title":"Changelog - v0.2.5","type":"extras"},{"doc":"Bug fixesFix warning due to missing Nerves.Runtime","ref":"changelog.html#v0-2-4","title":"Changelog - v0.2.4","type":"extras"},{"doc":"Bug fixesFix cmd/1 to capture and print stderr as well. This fixes an issue where stderr prints would go somewhere else and you couldn't see them. This affected IEx sessions running over ssh.","ref":"changelog.html#v0-2-3","title":"Changelog - v0.2.3","type":"extras"},{"doc":"Bug fixesFix ifconfig crash on sit interfacesImprove printout of unnamed pids with topNew featuresAdd uptime helper","ref":"changelog.html#v0-2-2","title":"Changelog - v0.2.2","type":"extras"},{"doc":"New featuresAdd exit for exiting an IEx session","ref":"changelog.html#v0-2-1","title":"Changelog - v0.2.1","type":"extras"},{"doc":"New featurestop displays deltas by defaultBug fixesFixed inclusion of Nerves utilities on Nerves","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]